import { EventBus, Events, EventWaiter, EventName } from '@eggjs/eventbus-decorator';
import { EggContext } from '@eggjs/tegg-runtime';
type Arguments<T> = [T] extends [(...args: infer U) => any] ? U : [T] extends [void] ? [] : [T];
export declare class SingletonEventBus implements EventBus, EventWaiter {
    private readonly emitter;
    private readonly eventContextFactory;
    private readonly eventHandlerFactory;
    private readonly logger;
    /**
     * only use for ensure event will happen
     */
    once<E extends keyof Events>(event: E, listener: Events[E]): this;
    await<E extends keyof Events>(event: E): Promise<Arguments<Events[E]>>;
    awaitFirst<E extends keyof Events>(...e: Array<E>): Promise<{
        event: EventName;
        args: Arguments<Events[E]>;
    }>;
    emit<E extends keyof Events>(event: E, ...args: Arguments<Events[E]>): boolean;
    emitWithContext<E extends keyof Events>(parentContext: EggContext, event: E, args: Arguments<Events[E]>): boolean;
    doOnceEmit<E extends keyof Events>(event: E, args: Arguments<Events[E]>): void;
    doEmit<E extends keyof Events>(ctx: EggContext, event: E, args: Arguments<Events[E]>): Promise<void>;
}
export {};
